#ifdef HAVE_VISIBILITY_ATTRIBUTE
# ifndef attribute_hidden
#  define attribute_hidden __attribute__ ((visibility ("hidden")))
# endif
#else
# ifndef attribute_hidden
#  define attribute_hidden
# endif
#endif

#define Rf_pnchisq pnmath_pnchisq
#define Rf_qnchisq pnmath_qnchisq
double pnmath_qnchisq(double, double, double, int, int);

#define Rf_bd0 pnmath_bd0
#define Rf_beta pnmath_beta
#define Rf_chebyshev_eval pnmath_chebyshev_eval
#define Rf_chebyshev_init pnmath_chebyshev_init
#define Rf_choose pnmath_choose
#define Rf_d1mach pnmath_d1mach
#define Rf_dbeta pnmath_dbeta
#define Rf_dbinom pnmath_dbinom
#define Rf_dcauchy pnmath_dcauchy
#define Rf_dchisq pnmath_dchisq
#define Rf_dexp pnmath_dexp
#define Rf_df pnmath_df
#define Rf_dgamma pnmath_dgamma
#define Rf_dgeom pnmath_dgeom
#define Rf_dhyper pnmath_dhyper
#define Rf_digamma pnmath_digamma
#define Rf_dlnorm pnmath_dlnorm
#define Rf_dlogis pnmath_dlogis
#define Rf_dnbeta pnmath_dnbeta
#define Rf_dnbinom pnmath_dnbinom
#define Rf_dnchisq pnmath_dnchisq
#define Rf_dnf pnmath_dnf
#define Rf_dnorm4 pnmath_dnorm4
#define Rf_dnt pnmath_dnt
#define Rf_dpois pnmath_dpois
#define Rf_dpsifn pnmath_dpsifn
#define Rf_dt pnmath_dt
#define Rf_dunif pnmath_dunif
#define Rf_dweibull pnmath_dweibull
#define Rf_fmax2 pnmath_fmax2
#define Rf_fmin2 pnmath_fmin2
#define Rf_gamma_cody pnmath_gamma_cody
#define Rf_gammafn pnmath_gammafn
#define Rf_i1mach pnmath_i1mach
#define Rf_imax2 pnmath_imax2
#define Rf_imin2 pnmath_imin2
#define Rf_lbeta pnmath_lbeta
#define Rf_lchoose pnmath_lchoose
#define Rf_lfastchoose pnmath_lfastchoose
#define Rf_lgamma1p pnmath_lgamma1p
#define Rf_lgammacor pnmath_lgammacor
#define Rf_lgammafn pnmath_lgammafn
#define Rf_log1pmx pnmath_log1pmx
#define Rf_logspace_add pnmath_logspace_add
#define Rf_logspace_sub pnmath_logspace_sub
#define Rf_pbeta pnmath_pbeta
#define Rf_pbeta_raw pnmath_pbeta_raw
#define Rf_pbinom pnmath_pbinom
#define Rf_pcauchy pnmath_pcauchy
#define Rf_pchisq pnmath_pchisq
#define Rf_pentagamma pnmath_pentagamma
#define Rf_pexp pnmath_pexp
#define Rf_pf pnmath_pf
#define Rf_pgamma pnmath_pgamma
#define Rf_pgeom pnmath_pgeom
#define Rf_phyper pnmath_phyper
#define Rf_plnorm pnmath_plnorm
#define Rf_plogis pnmath_plogis
#define Rf_pnbeta pnmath_pnbeta
#define Rf_pnbinom pnmath_pnbinom
#define Rf_pnf pnmath_pnf
#define Rf_pnorm5 pnmath_pnorm5
#define Rf_pnorm_both pnmath_pnorm_both
#define Rf_pnt pnmath_pnt
#define Rf_ppois pnmath_ppois
#define Rf_psigamma pnmath_psigamma
#define Rf_pt pnmath_pt
#define Rf_ptukey pnmath_ptukey
#define Rf_punif pnmath_punif
#define Rf_pweibull pnmath_pweibull
#define Rf_qbeta pnmath_qbeta
#define Rf_qbinom pnmath_qbinom
#define Rf_qcauchy pnmath_qcauchy
#define Rf_qchisq pnmath_qchisq
#define Rf_qchisq_appr pnmath_qchisq_appr
#define Rf_qexp pnmath_qexp
#define Rf_qf pnmath_qf
#define Rf_qgamma pnmath_qgamma
#define Rf_qgeom pnmath_qgeom
#define Rf_qhyper pnmath_qhyper
#define Rf_qlnorm pnmath_qlnorm
#define Rf_qlogis pnmath_qlogis
#define Rf_qnbeta pnmath_qnbeta
#define Rf_qnbinom pnmath_qnbinom
#define Rf_qnf pnmath_qnf
#define Rf_qnorm5 pnmath_qnorm5
#define Rf_qnt pnmath_qnt
#define Rf_qpois pnmath_qpois
#define Rf_qt pnmath_qt
#define Rf_qtukey pnmath_qtukey
#define Rf_qunif pnmath_qunif
#define Rf_qweibull pnmath_qweibull
#define Rf_sign pnmath_sign
#define Rf_ftrunc pnmath_ftrunc
#define Rf_stirlerr pnmath_stirlerr
#define Rf_tetragamma pnmath_tetragamma
#define Rf_trigamma pnmath_trigamma

	/* Normal Distribution */

#define pnorm pnorm5
#define qnorm qnorm5
#define dnorm dnorm4

double	dnorm(double, double, double, int);
double	pnorm(double, double, double, int, int);
double	qnorm(double, double, double, int, int);

	/* Uniform Distribution */

double	dunif(double, double, double, int);
double	punif(double, double, double, int, int);
double	qunif(double, double, double, int, int);

	/* Gamma Distribution */

double	dgamma(double, double, double, int);
double	pgamma(double, double, double, int, int);
double	qgamma(double, double, double, int, int);

double  log1pmx(double);
double  lgamma1p(double);
double  logspace_add(double, double);
double  logspace_sub(double, double);

	/* Beta Distribution */

double	dbeta(double, double, double, int);
double	pbeta(double, double, double, int, int);
double	qbeta(double, double, double, int, int);

	/* Lognormal Distribution */

double	dlnorm(double, double, double, int);
double	plnorm(double, double, double, int, int);
double	qlnorm(double, double, double, int, int);

	/* Chi-squared Distribution */

double	dchisq(double, double, int);
double	pchisq(double, double, int, int);
double	qchisq(double, double, int, int);

	/* Non-central Chi-squared Distribution */

double	dnchisq(double, double, double, int);
double	pnchisq(double, double, double, int, int);
double	qnchisq(double, double, double, int, int);

	/* F Distibution */

double	df(double, double, double, int);
double	pf(double, double, double, int, int);
double	qf(double, double, double, int, int);

	/* Student t Distibution */

double	dt(double, double, int);
double	pt(double, double, int, int);
double	qt(double, double, int, int);

	/* Binomial Distribution */

double	dbinom(double, double, double, int);
double	pbinom(double, double, double, int, int);
double	qbinom(double, double, double, int, int);

	/* Multnomial Distribution */

void	rmultinom(int, double*, int, int*);

	/* Cauchy Distribution */

double	dcauchy(double, double, double, int);
double	pcauchy(double, double, double, int, int);
double	qcauchy(double, double, double, int, int);

	/* Exponential Distribution */

double	dexp(double, double, int);
double	pexp(double, double, int, int);
double	qexp(double, double, int, int);

	/* Geometric Distribution */

double	dgeom(double, double, int);
double	pgeom(double, double, int, int);
double	qgeom(double, double, int, int);

	/* Hypergeometric Distibution */

double	dhyper(double, double, double, double, int);
double	phyper(double, double, double, double, int, int);
double	qhyper(double, double, double, double, int, int);

	/* Negative Binomial Distribution */

double	dnbinom(double, double, double, int);
double	pnbinom(double, double, double, int, int);
double	qnbinom(double, double, double, int, int);

	/* Poisson Distribution */

double	dpois(double, double, int);
double	ppois(double, double, int, int);
double	qpois(double, double, int, int);

	/* Weibull Distribution */

double	dweibull(double, double, double, int);
double	pweibull(double, double, double, int, int);
double	qweibull(double, double, double, int, int);

	/* Logistic Distribution */

double	dlogis(double, double, double, int);
double	plogis(double, double, double, int, int);
double	qlogis(double, double, double, int, int);

	/* Non-central Beta Distribution */

double	dnbeta(double, double, double, double, int);
double	pnbeta(double, double, double, double, int, int);
double	qnbeta(double, double, double, double, int, int);

	/* Non-central F Distribution */

double  dnf(double, double, double, double, int);
double	pnf(double, double, double, double, int, int);
double	qnf(double, double, double, double, int, int);

	/* Non-central Student t Distribution */

double	dnt(double, double, double, int);
double	pnt(double, double, double, int, int);
double	qnt(double, double, double, int, int);

	/* Studentized Range Distribution */

double	ptukey(double, double, double, double, int, int);
double	qtukey(double, double, double, double, int, int);

	/* Wilcoxon Rank Sum Distribution */

double dwilcox(double, double, double, int);
double pwilcox(double, double, double, int, int);
double qwilcox(double, double, double, int, int);

	/* Wilcoxon Signed Rank Distribution */

double dsignrank(double, double, int);
double psignrank(double, double, int, int);
double qsignrank(double, double, int, int);


	/* Gamma and Related Functions */
double	gammafn(double);
double	lgammafn(double);
void    dpsifn(double, int, int, int, double*, int*, int*);
double	psigamma(double, double);
double	digamma(double);
double	trigamma(double);
double	tetragamma(double);
double	pentagamma(double);

double	beta(double, double);
double	lbeta(double, double);

double	choose(double, double);
double	lchoose(double, double);

	/* Bessel Functions */

double	bessel_i(double, double, double);
double	bessel_j(double, double);
double	bessel_k(double, double, double);
double	bessel_y(double, double);


	/* General Support Functions */

int	imax2(int, int);
int	imin2(int, int);
double	fmax2(double, double);
double	fmin2(double, double);
double	sign(double);
double	ftrunc(double);

double attribute_hidden lfastchoose(double, double);
#define gamma_cody	Rf_gamma_cody
double	gamma_cody(double); /* used in arithmetic.c */

double lgammafn_sign(double, int *);

